# !/usr/bin/python

# Copyright (c) 2007 Randal Barlow
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.
import sys, os
import gobject
import pygtk
import gtk
from gtk import gdk
import awn
import gconf
import netbus
import time
class App (awn.AppletSimple):
    """
    """
    def __init__ (self, uid, orient, height):
        """
        Creating the applets core
        """
        # netbus modules
        self.nbus = netbus.NetBus()
        ########
        # temp
        self.nbus.setDevice('ath0')
        ########
        # The Heart     
        self.resultToolTip                  = "Network Manager"
        awn.AppletSimple.__init__             (self, uid, orient, height)
        self.height                         = height
        icon                                = gdk.pixbuf_new_from_file ("/usr/share/icons/Tango/scalable/devices/network-wireless.svg")
        if height != icon.get_height():
            icon = icon.scale_simple(height,height,gtk.gdk.INTERP_BILINEAR)
        self.set_icon                         (icon)
        self.title                          = awn.awn_title_get_default ()
        self.dialog                         = awn.AppletDialog (self)
        self.dialog.set_title (' Network Manager ')
        # Defining Widgets
        vbox                                = gtk.VBox()
        hbox                                = gtk.HBox()
        self.hbox1                          = gtk.HBox()        
        self.vbox1                          = gtk.VBox()
        self.hbox2                          = gtk.HBox()  
        hbox3 = gtk.HBox()      
        self.combo                          = gtk.combo_box_new_text()
        self.progress                       = gtk.ProgressBar()
        self.label                          = gtk.Label()
        button1                             = gtk.ToolButton ("gtk-apply")
        self.image                          = gtk.Image()
        #
        # selected network display
        
        self.progress2 = gtk.ProgressBar()
        self.snl3 = gtk.Label()
        self.snl3.set_markup("<b>Encrypted: </b>")
        self.snl3.set_alignment(0,0)
        self.snl4 = gtk.Label()
        self.snl4.set_alignment(0,0)
        self.hbox1.pack_start(self.progress2)
        self.hbox2.pack_start(self.snl3)
        self.hbox2.add(self.snl4)
        self.vbox1.pack_start(self.hbox1)
        self.vbox1.add(self.hbox2)
        #
        # Packing Widgets
        hbox.pack_start                       (self.combo)
        hbox.add                              (button1)
        vbox.pack_start                       (self.image)
        vbox.add                              (self.label)
        hbox3.pack_start                      (self.progress)
        #hbox3.add                             (self.progress)
        vbox.add                              (hbox3)
        vbox.add                              (hbox)
        vbox.add                              (self.vbox1)
        self.dialog.add                       (vbox)
        hbox.show_all                         ()
        vbox.show_all                         ()

        # Standard AWN Connects
        self.connect                          ("button-press-event", self.button_press)
        self.connect                          ("enter-notify-event", self.enter_notify)
        self.connect                          ("leave-notify-event", self.leave_notify)
        self.dialog.connect                   ("focus-out-event", self.dialog_focus_out)

        # Button Connects
        self.combo.connect                    ("changed", self.updateSelectedLabel)
        button1.connect                       ("clicked", self.networkConnect)
        #button_play.connect                   ("clicked", self.button_pp_press)
        #button_next.connect                   ("clicked", self.button_next_press)
        self.updateLabel()
    def networkConnect(self,widget):
        a = self.combo.get_active_text()
        if a != '' or None:
            self.nbus.setActiveDevice('ath0',a)
            self.dialog.hide()
        time.sleep(4)
    def updateLabel(self):
        device = 'ath0'
        check,network = self.nbus.getActiveNetwork(None)
        if check is False:
            self.label.set_markup("<b>" + "Current: " + "None" + "</b>")            
        else:
            self.label.set_markup("<b>" + "Current: " + network + "</b>")
            lv = self.nbus.getNetworkStrength(None,network).__str__()
            self.progress.set_fraction(eval(lv) * 0.01)
            self.progress.set_text(lv)
        
    def updateSelectedLabel(self,widget):
        network = self.combo.get_active_text()
        if network != '' or None:
            print network
            lv = self.nbus.getNetworkStrength(None,network).__str__()
            self.progress2.set_fraction(eval(lv) * 0.01)
            self.progress2.set_text(lv)
            if self.nbus.getNetworkEncrypted(None,network).__str__() == '1':
                self.snl4.set_markup("Yes")
            else: self.snl4.set_markup('No')
    ############
    # App Methods
    ############
    def updateNetworkCombo(self):
        if 'netlist' not in self.__dict__: self.netlist = []
        vary,var1 = self.nbus.getNetworks(None)
        if vary is True:
            for item in var1:
                #try:
                #    while True:
                #        self.combo.remove_text(0)
                #except:pass
                if item not in self.netlist: 
                    self.netlist.append(item)
                    self.combo.append_text(item)
                else:pass
      
    #############
    # Applet standard methods    
    #############
    def button_press                          (self, widget, event):
        if "_VISIBLE" in self.dialog.flags().__str__():
            self.dialog.hide                  ()
            self.title.hide                   (self)
        else:
            try:self.updateLabel()
            except:pass
            self.updateNetworkCombo           ()
            self.dialog.show_all              ()
            self.title.hide                   (self)
        
    def dialog_focus_out                      (self, widget, event):
        #self.dialog.hide                      ()
        print 'out'
    def enter_notify                          (self, widget, event):
        self.title.show                       (self, self.resultToolTip)
    def leave_notify                          (self, widget, event):
        self.title.hide                       (self)
    #############
    # Gconf
    ############# 
    def key_control(self,keyname,default):
        """
        This Method takes the keyname and the defualt value and either loads an existing key -or- loads and saves the defualt key if no key is defined
        """
        keylocation_with_name               = self.keylocation + keyname
        try:
            var                             = self.client.get_string(keylocation_with_name)
            if var                         == None:
                var                         = default
                self.client.set_string        (keylocation_with_name,var)
        except NameError:
            var                             = default
        return var     
    def load_keys(self):
        """
        Loads all the gconf variables by calling the key_control method 
        """
        self.client                         = gconf.client_get_default()
        #self.player_name                    = self.key_control ("PlayerName","Rhythmbox")

    #############
    # Rhythmbox specific control methods
    #############

if __name__ == "__main__":
    awn.init                      (sys.argv[1:])
    applet = App                  (awn.uid, awn.orient,awn.height)
    awn.init_applet               (applet)
    applet.show_all               ()
    gtk.main                      ()
